#!/usr/bin/env python2.1

##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
# 
##############################################################################

__version__ = '$Id: partition.py,v 1.2 2002/02/25 18:45:41 andreas Exp $'

import os,sys
import weblog.common,getopt
import time
from common.Request import Request
from random import Random,randrange

duration  = 3600
RD = Random(time.time())

requests = []

START = time.mktime((2001,11,12,9,30,0,0,0,0))
END   = time.mktime((2001,11,12,9,40,0,0,0,0))



def reqsort(a,b):
    return cmp(a.timestamp,b.timestamp)


def parseFiles(files):

    for f in files:
        print f

        vhost = os.path.basename(f).replace('.com_hostname_access','') \
		 + '.cbs.zope.com'

        log = weblog.common.Parser(open(f))

        read = 0
        while log.getlogent():
            read+=1

            if log.utime<START or log.utime>END: continue

            if read % 10000 ==0:
                print read


            if randrange(0,5)<2:
                throttle = 8.0*log.bytes/56000
            else:
                throttle = 0.0

            req = Request(  
                    timestamp=log.utime,
                    method=log.method,
                    path=log.url,
                    throttle = throttle,
                    headers={'host':vhost}
                    )


            requests.append( req )


    # Now sort the requests by ip and date
    requests.sort(reqsort)

    fp = open('partition.dat','w')
    ts = requests[0].timestamp
    for r in requests: 
        r.timestamp = r.timestamp - ts        
        fp.write(str(r) + '\n')

    fp.close()


def usage():
    print '%s --duration <n secs>  files ...' %\
        os.path.basename(sys.argv[0])


def main():

    opts,args = getopt.getopt(sys.argv[1:],'h', \
		['help'])

    for o,v in opts:
        if o in ['--help','-h']:        usage(); sys.exit(1) 

    parseFiles(args)
    os._exit(0)

if __name__=='__main__':
    main()
