##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
# 
##############################################################################

import threading, traceback
import socket, random, time

class UDPServerThread(threading.Thread):
    """ UDP based serverithread """

    running = 1

    def __init__(self, port):
        threading.Thread.__init__(self)

        self.port = port

        g = random.seed(time.time())
        self.DIE_MSG = str(random.randrange(0,9e8)) + \
                       str(random.randrange(0,9e8))

        self.sock = socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
        self.sock.bind( ('',port))


    def run(self):

        while self.running:
            data,addr = self.getdata()

        self.sock.close()

    def getdata(self):

        data,addr = self.sock.recvfrom(200000)
        if data.startswith(self.DIE_MSG):
            self.running = 0

        return data,addr



    def stop(self):

        s = socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
        s.sendto(self.DIE_MSG, ('',self.port))
        s.close()


def test():

    srv = UDPServerThread(23312)
    srv.start()

    print 'server started'
    time.sleep(2)
    print "requesting to die"
    srv.stop()
    srv.join()
    print 'died'


if __name__=='__main__':
    test()
        

